
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux Shell脚本之远程自动化部署java maven项目 / iVAN</title>

    <meta name="description" content="Linux Shell脚本之远程自动化部署java maven项目 原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://dgd2010.blog.51cto.com/1539422/1771555 脚本功能: 检查运行环境(包括运行权限.网络.DNS解析等),自动从git上获取java maven项目工程源码,在机器A上build,build完成后,备份机器B上原有的配置文件(如果存在),将Class.Lib文件和备份的配置文件等上传到机器B,重新启动机器B上的服务以便变更生效. 脚本特点: 1.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Linux Shell脚本之远程自动化部署java maven项目</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原创作品，允许转载，转载时请务必以超链接形式标明文章 <a href="http://dgd2010.blog.51cto.com/1539422/1771555" rel="external nofollow noreferrer">原始出处</a> 、作者信息和本声明。否则将追究法律责任。<a href="http://dgd2010.blog.51cto.com/1539422/1771555" rel="external nofollow noreferrer">http://dgd2010.blog.51cto.com/1539422/1771555</a></p>
<p><strong>脚本功能：</strong></p>
<p>检查运行环境（包括运行权限、网络、DNS解析等），自动从git上获取java maven项目工程源码，在机器A上build，build完成后，备份机器B上原有的配置文件（如果存在），将Class、Lib文件和备份的配置文件等上传到机器B，重新启动机器B上的服务以便变更生效。</p>
<p><strong>脚本特点：</strong></p>
<p>1.（与之前的自动部署脚本相比）全新优化了脚本代码，更friendly，结构更紧凑、逻辑更加严谨</p>
<p>2.Public header删除了无用或者不好用的有色彩显示函数，并修正了WORKDIR不是绝对路径可能导致的bug</p>
<p>3.修正了域名解析判断是否正常的一个bug，该bug可能导致遇到无法解析后不断尝试解析</p>
<p>4.全新的通用main函数，自带文件锁和自动接受处理INT、TERM、EXIT进程信号，整个脚本更加的模块化和标准化</p>
<p>5.针对项目方面，增加了对java项目配置文件的备份和还原功能，增加了对docker容器的支持</p>
<p><strong>使用办法：</strong></p>
<p>将脚本上传到Linux任意目录，至少修改三个变量（分别是项目源码的git地址、部署对象的IP、部署对象的目标目录）：</p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3
</td>
<td>
<p><code>project_clone=</code><code>"ssh://git@xxx/xxx.git"</code></p>
<p><code>deploy_target_host_ip=</code><code>"xxx.xxx.xxx.xxx"</code></p>
<p><code>project_top_directory_to_target_host=</code><code>"/path/to/deploy/project"</code></p>
</td>
</tr>
</tbody>
</table>
<p>如果此项目依赖于其他项目，则修改“project_clone_depends_1”变量，如果要想使部署后自动生效，则，可以将启动脚本放在项目git源码下的bin目录下，默认名称为“startup.sh”</p>
<p>如果此项目部署在目标主机的docker容器内，则修改“docker_container_name”变量，以便重启容器生效。</p>
<p>多个容器启动的依赖关系的处理已经在TODO计划中。</p>
<p>首次执行需要将配置文件准确的写入项目文件中，一次写入后期无须修改，如需修改，直接修改部署对象主机上的配置文件即可。</p>
<p>在任意位置使用下方命令运行即可，脚本一旦运行一次，自动添加可执行权限，无须手动添加。</p>
<table>
<tbody>
<tr>
<td>
<br />1
</td>
<td>
<p><code>bash</code> <code>/path/to/this</code><code>.sh</code></p>
</td>
</tr>
</tbody>
</table>
<p>可以从GitHub上获取最新脚本内容：<a href="https://github.com/DingGuodong/AutomaticDeployJavaMavenProject" rel="external nofollow noreferrer">https://github.com/DingGuodong/AutomaticDeployJavaMavenProject</a></p>
<p><strong>脚本内容：</strong></p>
<table>
<tbody>
<tr>
<td>
<br />1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46</p>
<p>47</p>
<p>48</p>
<p>49</p>
<p>50</p>
<p>51</p>
<p>52</p>
<p>53</p>
<p>54</p>
<p>55</p>
<p>56</p>
<p>57</p>
<p>58</p>
<p>59</p>
<p>60</p>
<p>61</p>
<p>62</p>
<p>63</p>
<p>64</p>
<p>65</p>
<p>66</p>
<p>67</p>
<p>68</p>
<p>69</p>
<p>70</p>
<p>71</p>
<p>72</p>
<p>73</p>
<p>74</p>
<p>75</p>
<p>76</p>
<p>77</p>
<p>78</p>
<p>79</p>
<p>80</p>
<p>81</p>
<p>82</p>
<p>83</p>
<p>84</p>
<p>85</p>
<p>86</p>
<p>87</p>
<p>88</p>
<p>89</p>
<p>90</p>
<p>91</p>
<p>92</p>
<p>93</p>
<p>94</p>
<p>95</p>
<p>96</p>
<p>97</p>
<p>98</p>
<p>99</p>
<p>100</p>
<p>101</p>
<p>102</p>
<p>103</p>
<p>104</p>
<p>105</p>
<p>106</p>
<p>107</p>
<p>108</p>
<p>109</p>
<p>110</p>
<p>111</p>
<p>112</p>
<p>113</p>
<p>114</p>
<p>115</p>
<p>116</p>
<p>117</p>
<p>118</p>
<p>119</p>
<p>120</p>
<p>121</p>
<p>122</p>
<p>123</p>
<p>124</p>
<p>125</p>
<p>126</p>
<p>127</p>
<p>128</p>
<p>129</p>
<p>130</p>
<p>131</p>
<p>132</p>
<p>133</p>
<p>134</p>
<p>135</p>
<p>136</p>
<p>137</p>
<p>138</p>
<p>139</p>
<p>140</p>
<p>141</p>
<p>142</p>
<p>143</p>
<p>144</p>
<p>145</p>
<p>146</p>
<p>147</p>
<p>148</p>
<p>149</p>
<p>150</p>
<p>151</p>
<p>152</p>
<p>153</p>
<p>154</p>
<p>155</p>
<p>156</p>
<p>157</p>
<p>158</p>
<p>159</p>
<p>160</p>
<p>161</p>
<p>162</p>
<p>163</p>
<p>164</p>
<p>165</p>
<p>166</p>
<p>167</p>
<p>168</p>
<p>169</p>
<p>170</p>
<p>171</p>
<p>172</p>
<p>173</p>
<p>174</p>
<p>175</p>
<p>176</p>
<p>177</p>
<p>178</p>
<p>179</p>
<p>180</p>
<p>181</p>
<p>182</p>
<p>183</p>
<p>184</p>
<p>185</p>
<p>186</p>
<p>187</p>
<p>188</p>
<p>189</p>
<p>190</p>
<p>191</p>
<p>192</p>
<p>193</p>
<p>194</p>
<p>195</p>
<p>196</p>
<p>197</p>
<p>198</p>
<p>199</p>
<p>200</p>
<p>201</p>
<p>202</p>
<p>203</p>
<p>204</p>
<p>205</p>
<p>206</p>
<p>207</p>
<p>208</p>
<p>209</p>
<p>210</p>
<p>211</p>
<p>212</p>
<p>213</p>
<p>214</p>
<p>215</p>
<p>216</p>
<p>217</p>
<p>218</p>
<p>219</p>
<p>220</p>
<p>221</p>
<p>222</p>
<p>223</p>
<p>224</p>
<p>225</p>
<p>226</p>
<p>227</p>
<p>228</p>
<p>229</p>
<p>230</p>
<p>231</p>
<p>232</p>
<p>233</p>
<p>234</p>
<p>235</p>
<p>236</p>
<p>237</p>
<p>238</p>
<p>239</p>
<p>240</p>
<p>241</p>
<p>242</p>
<p>243</p>
<p>244</p>
<p>245</p>
<p>246</p>
<p>247</p>
<p>248</p>
<p>249</p>
<p>250</p>
<p>251</p>
<p>252</p>
<p>253</p>
<p>254</p>
<p>255</p>
<p>256</p>
<p>257</p>
<p>258</p>
<p>259</p>
<p>260</p>
<p>261</p>
<p>262</p>
<p>263</p>
<p>264</p>
<p>265</p>
<p>266</p>
<p>267</p>
<p>268</p>
<p>269</p>
<p>270</p>
<p>271</p>
<p>272</p>
<p>273</p>
<p>274</p>
<p>275</p>
<p>276</p>
<p>277</p>
<p>278</p>
<p>279</p>
<p>280</p>
<p>281</p>
<p>282</p>
<p>283</p>
<p>284</p>
<p>285</p>
<p>286</p>
<p>287</p>
<p>288</p>
<p>289</p>
<p>290</p>
<p>291</p>
<p>292</p>
<p>293</p>
<p>294</p>
<p>295</p>
<p>296</p>
<p>297</p>
<p>298</p>
<p>299</p>
<p>300</p>
<p>301</p>
<p>302</p>
<p>303</p>
<p>304</p>
<p>305</p>
<p>306</p>
<p>307</p>
<p>308</p>
<p>309</p>
<p>310</p>
<p>311</p>
<p>312</p>
<p>313</p>
<p>314</p>
<p>315</p>
<p>316</p>
<p>317</p>
<p>318</p>
<p>319</p>
<p>320</p>
<p>321</p>
<p>322</p>
<p>323</p>
<p>324</p>
<p>325</p>
<p>326</p>
<p>327</p>
<p>328</p>
<p>329</p>
<p>330</p>
<p>331</p>
<p>332</p>
<p>333</p>
<p>334</p>
<p>335</p>
<p>336</p>
<p>337</p>
<p>338</p>
<p>339</p>
<p>340</p>
<p>341</p>
<p>342</p>
<p>343</p>
<p>344</p>
<p>345</p>
<p>346</p>
<p>347</p>
<p>348</p>
<p>349</p>
<p>350</p>
<p>351</p>
<p>352</p>
<p>353</p>
<p>354</p>
<p>355</p>
<p>356</p>
<p>357</p>
<p>358</p>
<p>359</p>
<p>360</p>
<p>361</p>
<p>362</p>
<p>363</p>
<p>364</p>
<p>365</p>
<p>366</p>
<p>367</p>
<p>368</p>
<p>369</p>
<p>370</p>
<p>371</p>
<p>372</p>
<p>373</p>
<p>374</p>
<p>375</p>
<p>376</p>
<p>377</p>
<p>378</p>
<p>379</p>
<p>380</p>
<p>381</p>
<p>382</p>
<p>383</p>
<p>384</p>
<p>385</p>
<p>386</p>
<p>387</p>
<p>388</p>
<p>389</p>
<p>390</p>
<p>391</p>
<p>392</p>
<p>393</p>
<p>394</p>
<p>395</p>
<p>396</p>
<p>397</p>
<p>398</p>
<p>399</p>
<p>400</p>
<p>401</p>
<p>402</p>
<p>403</p>
<p>404</p>
<p>405</p>
<p>406</p>
<p>407</p>
<p>408</p>
<p>409</p>
<p>410</p>
<p>411</p>
<p>412</p>
<p>413</p>
<p>414</p>
<p>415</p>
<p>416</p>
<p>417</p>
<p>418</p>
<p>419</p>
<p>420</p>
<p>421</p>
<p>422</p>
<p>423</p>
<p>424</p>
<p>425</p>
<p>426</p>
<p>427</p>
<p>428</p>
<p>429</p>
<p>430</p>
<p>431</p>
<p>432</p>
<p>433</p>
<p>434</p>
<p>435</p>
<p>436</p>
<p>437</p>
<p>438</p>
<p>439</p>
<p>440</p>
<p>441</p>
<p>442</p>
<p>443</p>
<p>444</p>
<p>445</p>
<p>446</p>
<p>447</p>
<p>448</p>
<p>449</p>
<p>450</p>
<p>451</p>
<p>452</p>
<p>453</p>
<p>454</p>
<p>455</p>
<p>456</p>
<p>457</p>
<p>458</p>
<p>459</p>
<p>460</p>
<p>461</p>
<p>462</p>
<p>463</p>
<p>464</p>
<p>465</p>
<p>466</p>
<p>467</p>
<p>468</p>
<p>469</p>
<p>470</p>
<p>471</p>
<p>472</p>
<p>473</p>
<p>474</p>
<p>475</p>
<p>476</p>
<p>477</p>
<p>478</p>
<p>479</p>
<p>480</p>
<p>481</p>
<p>482</p>
<p>483</p>
<p>484</p>
<p>485</p>
<p>486</p>
<p>487</p>
<p>488</p>
<p>489</p>
<p>490</p>
<p>491</p>
<p>492</p>
<p>493</p>
<p>494</p>
<p>495</p>
<p>496</p>
<p>497</p>
<p>498</p>
<p>499</p>
<p>500</p>
<p>501</p>
<p>502</p>
<p>503</p>
<p>504</p>
<p>505</p>
<p>506</p>
<p>507</p>
<p>508</p>
<p>509</p>
<p>510</p>
<p>511</p>
<p>512</p>
<p>513</p>
<p>514</p>
<p>515</p>
<p>516</p>
<p>517</p>
<p>518</p>
<p>519</p>
<p>520</p>
<p>521</p>
<p>522</p>
<p>523</p>
<p>524</p>
<p>525</p>
<p>526</p>
<p>527</p>
<p>528</p>
<p>529</p>
<p>530</p>
<p>531</p>
<p>532</p>
<p>533</p>
<p>534</p>
<p>535</p>
<p>536</p>
<p>537</p>
<p>538</p>
<p>539</p>
<p>540</p>
<p>541</p>
<p>542</p>
<p>543</p>
<p>544</p>
<p>545</p>
<p>546</p>
<p>547</p>
<p>548</p>
<p>549</p>
<p>550</p>
<p>551</p>
<p>552</p>
<p>553</p>
<p>554</p>
<p>555</p>
<p>556</p>
<p>557</p>
<p>558</p>
<p>559</p>
<p>560</p>
<p>561</p>
<p>562</p>
<p>563</p>
<p>564</p>
<p>565</p>
<p>566</p>
<p>567</p>
<p>568</p>
<p>569</p>
<p>570</p>
<p>571</p>
<p>572</p>
<p>573</p>
<p>574</p>
<p>575</p>
<p>576</p>
<p>577</p>
<p>578</p>
<p>579</p>
<p>580</p>
<p>581</p>
<p>582</p>
<p>583</p>
<p>584</p>
<p>585</p>
<p>586</p>
<p>587</p>
<p>588</p>
<p>589</p>
<p>590</p>
<p>591</p>
<p>592</p>
<p>593</p>
<p>594</p>
<p>595</p>
<p>596</p>
<p>597</p>
<p>598</p>
<p>599</p>
<p>600</p>
<p>601</p>
<p>602</p>
<p>603</p>
<p>604</p>
<p>605</p>
<p>606</p>
<p>607</p>
<p>608</p>
<p>609</p>
<p>610</p>
<p>611</p>
<p>612</p>
<p>613</p>
<p>614</p>
<p>615</p>
<p>616</p>
<p>617</p>
<p>618</p>
<p>619</p>
<p>620</p>
<p>621</p>
<p>622</p>
<p>623</p>
<p>624</p>
<p>625</p>
<p>626</p>
<p>627</p>
<p>628</p>
<p>629</p>
<p>630</p>
<p>631</p>
<p>632</p>
<p>633</p>
<p>634</p>
<p>635</p>
<p>636</p>
<p>637</p>
<p>638</p>
<p>639</p>
<p>640</p>
<p>641</p>
<p>642</p>
<p>643</p>
<p>644</p>
<p>645</p>
<p>646</p>
<p>647
</td>
<td>
<p><code>#!/bin/bash</code></p>
<p> </p>
<p><code># Name: doDeploy.sh</code></p>
<p><code>#Execute this shell script to deploy Java projects built by Maven automatically on remote hosts.</code></p>
<p> </p>
<p><code># debug option</code></p>
<p><code>#_XTRACE_FUNCTIONS=$(set +o | grep xtrace)</code></p>
<p><code>#set -o xtrace</code></p>
<p> </p>
<p><code># define user friendly messages</code></p>
<p><code>header="</code></p>
<p><code>Function: Execute this shell script to deploy Java projects built by Maven automatically on remote hosts.</code></p>
<p><code>License: Open </code><code>source</code> <code>software</code></p>
<p><code>"</code></p>
<p> </p>
<p><code># define variables</code></p>
<p><code># Where to get source code</code></p>
<p><code>project_clone_depends_1=</code><code>""</code></p>
<p><code>project_clone=</code><code>"ssh://git@xxx/xxx.git"</code></p>
<p><code>deploy_target_host_ip=</code><code>"xxx.xxx.xxx.xxx"</code></p>
<p><code>project_top_directory_to_target_host=</code><code>"/path/to/deploy/project"</code></p>
<p><code>docker_container_name=</code><code>""</code></p>
<p><code># Setting how many days do you want save old releases, default is 10 days</code></p>
<p><code>save_old_releases_for_days=10</code></p>
<p><code># end define variables</code></p>
<p> </p>
<p><code># pretreatment</code></p>
<p><code>test</code> <code>-z ${project_clone_depends_1} || project_clone_target_depends_1=</code><code>"`echo ${project_clone_depends_1} | awk -F '[/.]+' '{ print $(NF-1)}'`"</code></p>
<p><code>project_clone_target=</code><code>"`echo ${project_clone} | awk -F '[/.]+' '{ print $(NF-1)}'`"</code></p>
<p><code>project_clone_repository_name=${project_clone_target}</code></p>
<p> </p>
<p><code># end pretreatment</code></p>
<p> </p>
<p><code># Public header</code></p>
<p><code># =============================================================================================================================</code></p>
<p><code># resolve links - $0 may be a symbolic link</code></p>
<p><code># learn from apache-tomcat-6.x.xx/bin/catalina.sh</code></p>
<p><code>PRG=</code><code>"$0"</code></p>
<p> </p>
<p><code>while</code> <code>[ -h </code><code>"$PRG"</code> <code>]; </code><code>do</code></p>
<p><code>  </code><code>ls</code><code>=`</code><code>ls</code> <code>-ld </code><code>"$PRG"</code><code>`</code></p>
<p><code>  </code><code>link=`</code><code>expr</code> <code>"$ls"</code> <code>: </code><code>'.*-&gt; \(.*\)$'</code><code>`</code></p>
<p><code>  </code><code>if</code> <code>expr</code> <code>"$link"</code> <code>: </code><code>'/.*'</code> <code>&gt; </code><code>/dev/null</code><code>; </code><code>then</code></p>
<p><code>    </code><code>PRG=</code><code>"$link"</code></p>
<p><code>  </code><code>else</code></p>
<p><code>    </code><code>PRG=`</code><code>dirname</code> <code>"$PRG"</code><code>`/</code><code>"$link"</code></p>
<p><code>  </code><code>fi</code></p>
<p><code>done</code></p>
<p> </p>
<p><code># Get standard environment variables</code></p>
<p><code>PRGDIR=`</code><code>dirname</code> <code>"$PRG"</code><code>`</code></p>
<p> </p>
<p><code># echo color function, smarter, learn from lnmp.org lnmp install.sh</code></p>
<p><code>function</code> <code>echo_r (){</code></p>
<p><code>    </code><code># Color red: Error, Failed</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>echo</code> <code>-e </code><code>"\033[31m$1\033[0m"</code></p>
<p><code>}</code></p>
<p><code>function</code> <code>echo_g (){</code></p>
<p><code>    </code><code># Color green: Success</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>echo</code> <code>-e </code><code>"\033[32m$1\033[0m"</code></p>
<p><code>}</code></p>
<p><code>function</code> <code>echo_y (){</code></p>
<p><code>    </code><code># Color yellow: Warning</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>echo</code> <code>-e </code><code>"\033[33m$1\033[0m"</code></p>
<p><code>}</code></p>
<p><code>function</code> <code>echo_b (){</code></p>
<p><code>    </code><code># Color blue: Debug, friendly prompt</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>echo</code> <code>-e </code><code>"\033[34m$1\033[0m"</code></p>
<p><code>}</code></p>
<p><code># end echo color function, smarter</code></p>
<p> </p>
<p><code>#WORKDIR="`realpath ${WORKDIR}`"</code></p>
<p><code>WORKDIR=</code><code>"`readlink -f ${PRGDIR}`"</code></p>
<p> </p>
<p><code># end public header</code></p>
<p><code># =============================================================================================================================</code></p>
<p> </p>
<p><code>USER=</code><code>"`id -un`"</code></p>
<p><code>LOGNAME=</code><code>"$USER"</code></p>
<p><code>if</code> <code>[ $UID -</code><code>ne</code> <code>0 ]; </code><code>then</code></p>
<p><code>    </code><code>echo</code> <code>"WARNING: Running as a non-root user, \"$LOGNAME\". Functionality may be unavailable. Only root can use some commands or options"</code></p>
<p><code>fi</code></p>
<p> </p>
<p><code>command_exists() {</code></p>
<p><code>    </code><code># which "$@" &gt;/dev/null 2&gt;&amp;1</code></p>
<p><code>    </code><code>command</code> <code>-</code><code>v</code> <code>"$@"</code> <code>&gt;</code><code>/dev/null</code> <code>2&gt;&amp;1</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>check_command_can_be_execute(){</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>command_exists $1</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>check_network_connectivity(){</code></p>
<p><code>    </code><code>echo_b </code><code>"checking network connectivity ... "</code></p>
<p><code>    </code><code>network_address_to_check=8.8.4.4</code></p>
<p><code>    </code><code>stable_network_address_to_check=114.114.114.114</code></p>
<p><code>    </code><code>ping_count=2</code></p>
<p><code>    </code><code>ping</code> <code>-c ${ping_count} ${network_address_to_check} &gt;</code><code>/dev/null</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>if</code> <code>ping</code> <code>-c ${ping_count} ${stable_network_address_to_check} &gt;</code><code>/dev/null</code><code>;</code><code>then</code></p>
<p><code>            </code><code>echo_g </code><code>"Network to $stable_network_address_to_check succeed! "</code></p>
<p><code>            </code><code>echo_y </code><code>"Note: network to $network_address_to_check failed once! maybe just some packages loss."</code></p>
<p><code>        </code><code>elif</code> <code>! ip route | </code><code>grep</code> <code>default &gt;</code><code>/dev/null</code><code>; </code><code>then</code></p>
<p><code>            </code><code>echo_r </code><code>"Network is unreachable, gateway is not set."</code></p>
<p><code>            </code><code>exit</code> <code>1</code></p>
<p><code>        </code><code>elif</code> <code>! </code><code>ping</code> <code>-c2 $(ip route | </code><code>awk</code> <code>'/default/ {print $3}'</code><code>) &gt;</code><code>/dev/null</code><code>; </code><code>then</code></p>
<p><code>            </code><code>echo_r </code><code>"Network is unreachable, gateway is unreachable."</code></p>
<p><code>            </code><code>exit</code> <code>1</code></p>
<p><code>        </code><code>else</code></p>
<p><code>            </code><code>echo_r </code><code>"Network is blocked! "</code></p>
<p><code>            </code><code>exit</code> <code>1</code></p>
<p><code>        </code><code>fi</code></p>
<p><code>    </code><code>elif</code> <code>[ ${retval} -</code><code>eq</code> <code>0 ]; </code><code>then</code></p>
<p><code>        </code><code>echo_g </code><code>"Check network connectivity passed! "</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>check_name_resolve(){</code></p>
<p><code>    </code><code>echo_b </code><code>"checking DNS name resolve ... "</code></p>
<p><code>    </code><code>target_name_to_resolve=</code><code>"github.com"</code></p>
<p><code>    </code><code>stable_target_name_to_resolve=</code><code>"www.aliyun.com"</code></p>
<p><code>    </code><code>ping_count=1</code></p>
<p><code>    </code><code>if</code> <code>! </code><code>ping</code>  <code>-c${ping_count} ${target_name_to_resolve} &gt;</code><code>/dev/null</code><code>; </code><code>then</code></p>
<p><code>        </code><code>echo_y </code><code>"Name lookup failed for $target_name_to_resolve with $ping_count times "</code></p>
<p><code>        </code><code>if</code> <code>ping</code>  <code>-c${ping_count} ${stable_target_name_to_resolve} &gt;</code><code>/dev/null</code><code>; </code><code>then</code></p>
<p><code>            </code><code>echo_g </code><code>"Name lookup success for $stable_target_name_to_resolve with $ping_count times "</code></p>
<p><code>        </code><code>fi</code></p>
<p><code>        </code><code>eval_md5sum_of_nameserver_config=</code><code>"`md5sum /etc/resolv.conf | awk '{ print $1 }'`"</code></p>
<p><code>        </code><code>if</code> <code>test</code> <code>${eval_md5sum_of_nameserver_config} = </code><code>"674ea91675cdfac353bffbf49dc593c3"</code><code>; </code><code>then</code></p>
<p><code>            </code><code>echo_y </code><code>"Nameserver config file is validated, but name lookup failed for $target_name_to_resolve with $ping_count times"</code></p>
<p><code>            </code><code>return</code> <code>0</code></p>
<p><code>        </code><code>fi</code></p>
<p><code>        </code><code>[ -f </code><code>/etc/resolv</code><code>.conf ] &amp;&amp; </code><code>cp</code> <code>/etc/resolv</code><code>.conf </code><code>/etc/resolv</code><code>.conf_$(</code><code>date</code> <code>+%Y%m%d%H%M%S)~</code></p>
<p><code>        </code><code>cat</code> <code>&gt;</code><code>/etc/resolv</code><code>.conf&lt;&lt;eof</code></p>
<p><code>nameserver 114.114.114.114</code></p>
<p><code>nameserver 8.8.4.4</code></p>
<p><code>eof</code></p>
<p><code>    </code><code>check_name_resolve</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"Check DNS name resolve passed! "</code></p>
<p><code>        </code><code>return</code> <code>0</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>checkOtherDependencies() {</code></p>
<p><code>    </code><code>echo_b </code><code>"Checking other dependencies for deploy procedure... "</code></p>
<p> </p>
<p><code>    </code><code>echo_b </code><code>"\tChecking user customized variables..."</code></p>
<p><code>    </code><code># Refer:</code></p>
<p><code>    </code><code># if [ -z ${var+x} ]; then</code></p>
<p><code>    </code><code>#     echo "var is unset"; else echo "var is set to '$var'"</code></p>
<p><code>    </code><code># fi</code></p>
<p><code>    </code><code># if [ "$var x" = " x" ]; then</code></p>
<p><code>    </code><code>#     echo "var is empty"; else echo "var is set to '$var'"</code></p>
<p><code>    </code><code># fi</code></p>
<p><code>    </code><code># if [ -z $var ]; then</code></p>
<p><code>    </code><code>#     echo "var is empty"; else echo "var is set to '$var'"</code></p>
<p><code>    </code><code># fi</code></p>
<p><code>    </code><code>if</code> <code>[[ -z ${project_clone} ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"Error: project_clone is undefined! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>elif</code> <code>[[ -z ${deploy_target_host_ip} ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"Error: deploy_target_host_ip is undefined! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>elif</code> <code>[[ -z ${project_top_directory_to_target_host} ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"Error: project_top_directory_to_target_host is undefined! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>echo_g </code><code>"\tChecking user customized variables passed! "</code></p>
<p> </p>
<p><code>    </code><code>echo_b </code><code>"\tChecking disk space available..."</code></p>
<p><code>    </code><code>disk_space_available=`</code><code>df</code> <code>${WORKDIR} | </code><code>tail</code> <code>-n1 | </code><code>awk</code> <code>'{print $(NF-2)}'</code><code>`</code></p>
<p><code>    </code><code>if</code> <code>[[ ${disk_space_available} -lt 2097152 ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_y </code><code>"Warning: Disk space of $WORKDIR is smaller than 2GB"</code></p>
<p><code>        </code><code>#exit 1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"\tChecking disk space available passed! "</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>    </code><code>echo_g </code><code>"All required dependencies check passed! "</code></p>
<p> </p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>setDirectoryStructureOnLocalHost() {</code></p>
<p><code>    </code><code>if</code> <code>[ -f ${WORKDIR}/.capistrano_ds_lock ];</code><code>then</code></p>
<p><code>        </code><code>echo_g </code><code>"Set directory structure has been done, skipping. "</code></p>
<p><code>        </code><code>return</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>echo_b </code><code>"Setting directory structure... "</code></p>
<p><code>    </code><code># learn from capistrano</code></p>
<p><code>    </code><code># Refer: http://capistranorb.com/documentation/getting-started/structure/</code></p>
<p><code>    </code><code># Refer: http://capistranorb.com/documentation/getting-started/structure/#</code></p>
<p> </p>
<p><code>    </code><code># ├── current -&gt; /var/www/my_app_name/releases/20150120114500/</code></p>
<p><code>    </code><code># ├── releases</code></p>
<p><code>    </code><code># │   ├── 20150080072500</code></p>
<p><code>    </code><code># │   ├── 20150090083000</code></p>
<p><code>    </code><code># │   ├── 20150100093500</code></p>
<p><code>    </code><code># │   ├── 20150110104000</code></p>
<p><code>    </code><code># │   └── 20150120114500</code></p>
<p><code>    </code><code># ├── repo</code></p>
<p><code>    </code><code># │   └── &lt;VCS related data&gt;</code></p>
<p><code>    </code><code># ├── revisions.log</code></p>
<p><code>    </code><code># └── shared</code></p>
<p><code>    </code><code>#     └── &lt;linked_files and linked_dirs&gt;</code></p>
<p> </p>
<p><code>    </code><code># current is a symlink pointing to the latest release. This symlink is updated at the end of a successful deployment. If the deployment fails in any step the current symlink still points to the old release.</code></p>
<p><code>    </code><code># releases holds all deployments in a timestamped folder. These folders are the target of the current symlink.</code></p>
<p><code>    </code><code># repo holds the version control system configured. In case of a git repository the content will be a raw git repository (e.g. objects, refs, etc.).</code></p>
<p><code>    </code><code># revisions.log is used to log every deploy or rollback. Each entry is timestamped and the executing user (username from local machine) is listed. Depending on your VCS data like branch names or revision numbers are listed as well.</code></p>
<p><code>    </code><code># shared contains the linked_files and linked_dirs which are symlinked into each release. This data persists across deployments and releases. It should be used for things like database configuration files and static and persistent user storage handed over from one release to the next.</code></p>
<p><code>    </code><code># The application is completely contained within the path of :deploy_to. If you plan on deploying multiple applications to the same server, simply choose a different :deploy_to path.</code></p>
<p> </p>
<p><code>    </code><code># Check directories for deploy</code></p>
<p><code>    </code><code>[ ! -d ${WORKDIR}</code><code>/release</code> <code>] &amp;&amp; </code><code>mkdir</code> <code>${WORKDIR}</code><code>/release</code></p>
<p><code>    </code><code>[ ! -d ${WORKDIR}</code><code>/repository</code> <code>] &amp;&amp; </code><code>mkdir</code> <code>${WORKDIR}</code><code>/repository</code></p>
<p><code>    </code><code>[ ! -d ${WORKDIR}</code><code>/share</code> <code>] &amp;&amp; </code><code>mkdir</code> <code>${WORKDIR}</code><code>/share</code></p>
<p><code>    </code><code># end directories structure</code></p>
<p> </p>
<p><code>    </code><code># Additional directories structure for full deploy operation</code></p>
<p><code>    </code><code># for backup remote host config file</code></p>
<p><code>    </code><code>[ ! -d ${WORKDIR}</code><code>/backup</code> <code>] &amp;&amp; </code><code>mkdir</code> <code>${WORKDIR}</code><code>/backup</code></p>
<p> </p>
<p><code>    </code><code># set a directories structure lock</code></p>
<p><code>    </code><code>touch</code> <code>${WORKDIR}/.capistrano_ds_lock</code></p>
<p><code>    </code><code>echo_g </code><code>"Set directory structure successfully! "</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>cleanOldReleases(){</code></p>
<p><code>    </code><code>save_days=${save_old_releases_for_days:-10}</code></p>
<p><code>    </code><code>if</code> <code>[ ! -d ${WORKDIR}</code><code>/release</code> <code>]; </code><code>then</code></p>
<p><code>        </code><code>echo_b </code><code>"Can NOT find release directory, skipping . "</code></p>
<p><code>        </code><code>return</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>need_clean=$(</code><code>find</code> <code>${WORKDIR}</code><code>/release</code> <code>-mtime +${save_days} -</code><code>exec</code> <code>ls</code> <code>'{}'</code> <code>\;)</code></p>
<p><code>    </code><code>if</code> <code>[ ! -z ${need_clean} ]; </code><code>then</code></p>
<p><code>        </code><code>echo_g </code><code>"Expired releases found and will be removed from project! "</code></p>
<p><code>        </code><code>find</code> <code>${WORKDIR}</code><code>/release</code> <code>-mtime +${save_days} -</code><code>exec</code> <code>rm</code> <code>-rf </code><code>'{}'</code> <code>\;</code></p>
<p><code>        </code><code>if</code> <code>[ $? -</code><code>eq</code> <code>0 ]; </code><code>then</code></p>
<p><code>            </code><code>echo_g </code><code>"Expired releases have removed from project! "</code></p>
<p><code>        </code><code>else</code></p>
<p><code>            </code><code>echo_r </code><code>"Can NOT remove expired releases, please alter to Admin users. "</code></p>
<p><code>        </code><code>fi</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"All releases are not expired, skipping. "</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>}</code></p>
<p> </p>
<p><code># git_project_clone repository branch</code></p>
<p><code>function</code> <code>git_project_clone(){</code></p>
<p><code>    </code><code>set</code> <code>-o errexit</code></p>
<p><code>    </code><code>[ $</code><code># -ge 1 ] &amp;&amp; project_clone_repository="$1"</code></p>
<p><code>    </code><code>project_clone_repository_name=</code><code>"`echo ${project_clone_repository} | awk -F '[/.]+' '{ print $(NF-1)}'`"</code></p>
<p><code>    </code><code>project_clone_directory=${WORKDIR}</code><code>/repository/</code><code>${project_clone_repository_name}</code></p>
<p><code>    </code><code>if</code> <code>test</code> <code>-n $2; </code><code>then</code></p>
<p><code>        </code><code>branch=</code><code>"$2"</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>branch=</code><code>"develop"</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>if</code> <code>test</code> <code>! -d ${project_clone_directory}; </code><code>then</code></p>
<p><code>        </code><code>echo_b </code><code>"git clone from $project_clone_repository"</code></p>
<p><code>        </code><code>git clone ${project_clone_repository} ${project_clone_directory} &gt;&gt;${WORKDIR}</code><code>/git_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>            </code><code># TODO(Guodong Ding) get branch names or revision numbers from VCS data</code></p>
<p> </p>
<p><code>        </code><code>cd</code> <code>${project_clone_directory}</code></p>
<p><code>        </code><code>git checkout ${branch} &gt;&gt;${WORKDIR}</code><code>/git_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>        </code><code>cd</code> <code>..</code></p>
<p><code>        </code><code>echo_g </code><code>"git clone from $project_clone_repository successfully! "</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_b </code><code>"git pull from $project_clone_repository"</code></p>
<p><code>        </code><code>cd</code> <code>${project_clone_directory}</code></p>
<p><code>        </code><code>git pull &gt;&gt;${WORKDIR}</code><code>/git_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>        </code><code>git checkout ${branch} &gt;&gt;${WORKDIR}</code><code>/git_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>        </code><code># TODO(Guodong Ding) get branch names or revision numbers from VCS data</code></p>
<p><code>        </code><code>cd</code> <code>..</code></p>
<p><code>        </code><code>echo_g </code><code>"git pull from $project_clone_repository successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>set</code> <code>+o errexit</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>maven_build_project_deprecated(){</code></p>
<p><code>    </code><code>set</code> <code>-o errexit</code></p>
<p><code>    </code><code>echo_b </code><code>"Do mvn build java project... "</code></p>
<p><code>    </code><code>check_command_can_be_execute mvn</code></p>
<p><code>    </code><code>[ $</code><code># -ge 1 ] &amp;&amp; project_clone_repository="$1"</code></p>
<p><code>    </code><code>project_clone_repository_name=</code><code>"`echo ${project_clone_repository} | awk -F '[/.]+' '{ print $(NF-1)}'`"</code></p>
<p><code>    </code><code>project_clone_directory=${WORKDIR}</code><code>/repository/</code><code>${project_clone_repository_name}</code></p>
<p><code>    </code><code>cd</code> <code>${project_clone_directory}</code></p>
<p><code>    </code><code>mvn </code><code>install</code> <code>&gt;&gt;${WORKDIR}</code><code>/mvn_build_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>    </code><code>mvn clean package &gt;&gt;${WORKDIR}</code><code>/mvn_build_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>    </code><code>cd</code> <code>..</code></p>
<p><code>    </code><code>echo_g </code><code>"Do mvn build java project finished with exit code 0! "</code></p>
<p><code>    </code><code>set</code> <code>+o errexit</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>maven_build_project(){</code></p>
<p><code>    </code><code>echo_b </code><code>"Do mvn build java project for `echo $1 | awk -F '[/.]+' '{ print $(NF-1)}'`... "</code></p>
<p><code>    </code><code>check_command_can_be_execute mvn</code></p>
<p><code>    </code><code>[ $</code><code># -ge 1 ] &amp;&amp; project_clone_repository="$1"</code></p>
<p><code>    </code><code>project_clone_repository_name=</code><code>"`echo ${project_clone_repository} | awk -F '[/.]+' '{ print $(NF-1)}'`"</code></p>
<p><code>    </code><code>project_clone_directory=${WORKDIR}</code><code>/repository/</code><code>${project_clone_repository_name}</code></p>
<p> </p>
<p><code>    </code><code>cd</code> <code>${project_clone_directory}</code></p>
<p><code>    </code><code>mvn </code><code>install</code> <code>&gt;&gt;${WORKDIR}</code><code>/mvn_build_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"mvn install failed! More details refer to ${WORKDIR}/mvn_build_$(date +%Y%m%d)_$$.log"</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"mvn install for ${project_clone_repository_name} successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>    </code><code>mvn clean package &gt;&gt;${WORKDIR}</code><code>/mvn_build_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log 2&gt;&amp;1</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"mvn clean package for ${project_clone_repository_name} failed! More details refer to ${WORKDIR}/mvn_build_$(date +%Y%m%d)_$$.log"</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"mvn clean package for ${project_clone_repository_name} successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>cd</code> <code>..</code></p>
<p><code>    </code><code>echo_g </code><code>"Do mvn build java project finished for ${project_clone_repository_name} with exit code 0! "</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>check_ssh_can_be_connect(){</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>echo_b </code><code>"Check if can ssh to remote host $1 ... "</code></p>
<p><code>    </code><code>check_command_can_be_execute </code><code>ssh</code> <code>|| </code><code>return</code> <code>1</code></p>
<p><code>    </code><code>ssh</code> <code>-i </code><code>/etc/ssh/ssh_host_rsa_key</code> <code>-p 22 -oStrictHostKeyChecking=no root@$1 </code><code>"uname -a &gt;/dev/null 2&gt;&amp;1"</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"Check ssh to remote host $1 failed! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"Check ssh to remote host $1 successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code># ssh_execute_command_on_remote_host hostname command</code></p>
<p><code>function</code> <code>ssh_execute_command_on_remote_host(){</code></p>
<p><code>    </code><code>[ $</code><code># -ne 2 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>ssh</code> <code>-i </code><code>/etc/ssh/ssh_host_rsa_key</code> <code>-p 22 -oStrictHostKeyChecking=no root@$1 </code><code>"$2"</code> <code>&gt;&gt;${WORKDIR}</code><code>/ssh_command_</code><code>$(</code><code>date</code> <code>+%Y%m%d)_$$.log</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"ssh execute command on remote host $2 failed! More details refer to ${WORKDIR}/ssh_command_$(date +%Y%m%d)_$$.log"</code></p>
<p><code>        </code><code>return</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"ssh execute command on remote host $2 successfully! "</code></p>
<p><code>        </code><code>return</code> <code>0</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>restart_docker_container(){</code></p>
<p><code>    </code><code>echo_b </code><code>"Restarting docker container..."</code></p>
<p><code>    </code><code>[ $</code><code># -ne 1 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code># TODO(Guodong Ding) if we need restart more related docker container</code></p>
<p><code>    </code><code>local</code> <code>docker_container_name=</code><code>""</code></p>
<p><code>    </code><code>test</code> <code>-n $1 &amp;&amp; docker_container_name=</code><code>"$1"</code></p>
<p><code>    </code><code>ssh_execute_command_on_remote_host </code><code>"docker restart $docker_container_name"</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"restart docker container for  $docker_container_name failed! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"restart docker container for $docker_container_name successfully! "</code></p>
<p><code>        </code><code>return</code> <code>0</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code># scp_local_files_to_remote_host local_path remote_hostname remote_path</code></p>
<p><code>function</code> <code>scp_local_files_to_remote_host(){</code></p>
<p><code>    </code><code>[ $</code><code># -ne 3 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>[ ! -d $1 -a ! -f $1 ] &amp;&amp; </code><code>return</code> <code>1</code></p>
<p><code>    </code><code>check_ssh_can_be_connect $2</code></p>
<p><code>    </code><code>scp</code> <code>-i </code><code>/etc/ssh/ssh_host_rsa_key</code> <code>-P 22 -oStrictHostKeyChecking=no -rp $1 root@$2:$3 &gt;</code><code>/dev/null</code> <code>2&gt;&amp;1</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"scp local files to remote host failed! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"scp local files to remote host successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>}</code></p>
<p> </p>
<p><code># scp_remote_files_to_local_host remote_hostname remote_path local_path</code></p>
<p><code>function</code> <code>scp_remote_files_to_local_host(){</code></p>
<p><code>    </code><code>[ $</code><code># -ne 3 ] &amp;&amp; return 1</code></p>
<p><code>    </code><code>check_ssh_can_be_connect $1</code></p>
<p><code>    </code><code>scp</code> <code>-i </code><code>/etc/ssh/ssh_host_rsa_key</code> <code>-P 22 -oStrictHostKeyChecking=no -rp root@$1:$2 $3 &gt;</code><code>/dev/null</code> <code>2&gt;&amp;1</code></p>
<p><code>    </code><code>retval=$?</code></p>
<p><code>    </code><code>if</code> <code>[ ${retval} -</code><code>ne</code> <code>0 ] ; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"scp remote files to local host failed! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_g </code><code>"scp remote files to local host successfully! "</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>backup_remote_host_config_files(){</code></p>
<p><code>    </code><code>echo_b </code><code>"backup remote host config files..."</code></p>
<p><code>    </code><code>scp_remote_files_to_local_host ${deploy_target_host_ip} ${project_top_directory_to_target_host}/* ${WORKDIR}</code><code>/backup</code></p>
<p><code>    </code><code># get config files</code></p>
<p><code>    </code><code>[ </code><code>"$(ls -A ${WORKDIR}/backup)"</code> <code>] &amp;&amp; </code><code>find</code> <code>${WORKDIR}</code><code>/backup/</code><code>. -</code><code>type</code> <code>f ! -name . -a ! -name </code><code>'*.xml*'</code> <code>-a ! -name </code><code>'*.properties*'</code> <code>-</code><code>exec</code> <code>rm</code> <code>-f -- </code><code>'{}'</code> <code>\;</code></p>
<p><code>    </code><code># remove empty directory</code></p>
<p><code>    </code><code>find</code> <code>${WORKDIR}</code><code>/backup/</code><code>. -empty -</code><code>type</code> <code>d -delete</code></p>
<p><code>    </code><code># TODO(Guodong Ding) improvements here</code></p>
<p><code>    </code><code>echo_g </code><code>"backup remote host config files finished."</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>rollback_remote_host_config_files(){</code></p>
<p><code>    </code><code>echo_b </code><code>"rollback remote host config files..."</code></p>
<p><code>    </code><code>#scp_local_files_to_remote_host ${WORKDIR}/backup ${deploy_target_host_ip} ${project_top_directory_to_target_host}</code></p>
<p><code>    </code><code>saved_IFS=$IFS</code></p>
<p><code>    </code><code>IFS=</code><code>' '</code></p>
<p><code>    </code><code>cd</code> <code>${WORKDIR}</code><code>/current</code></p>
<p><code>    </code><code>for</code> <code>file</code> <code>in</code> <code>${WORKDIR}</code><code>/backup/</code><code>*;</code><code>do</code></p>
<p><code>        </code><code>scp_local_files_to_remote_host ${</code><code>file</code><code>} ${deploy_target_host_ip} ${project_top_directory_to_target_host}</code></p>
<p><code>    </code><code>done</code></p>
<p><code>    </code><code>cd</code> <code>${WORKDIR}</code></p>
<p><code>    </code><code>IFS=${saved_IFS}</code></p>
<p><code>    </code><code># TODO(Guodong Ding) if save remote host config files</code></p>
<p><code>    </code><code># some ops</code></p>
<p> </p>
<p><code>    </code><code># TODO(Guodong Ding) improvements here</code></p>
<p><code>    </code><code>echo_g </code><code>"rollback remote host config files finished."</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>deploy() {</code></p>
<p><code>    </code><code>[ -n </code><code>"$header"</code> <code>] &amp;&amp; </code><code>echo</code> <code>"$header"</code></p>
<p><code>    </code><code># check a directories lock, Note: this is redundant</code></p>
<p><code>    </code><code>if</code> <code>[[ ! -f ${WORKDIR}/.lock ]]; </code><code>then</code></p>
<p><code>        </code><code>setDirectoryStructureOnLocalHost</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>cleanOldReleases</code></p>
<p><code>    </code><code># do dependencies checking</code></p>
<p><code>    </code><code>check_network_connectivity</code></p>
<p><code>    </code><code>check_name_resolve</code></p>
<p><code>    </code><code>checkOtherDependencies</code></p>
<p> </p>
<p><code>    </code><code>check_ssh_can_be_connect ${deploy_target_host_ip}</code></p>
<p> </p>
<p><code>    </code><code># do core job</code></p>
<p><code>    </code><code># TODO(Guodong Ding) if we need a git_project_clone "$project_clone_depends_1" here using auto judgment statement</code></p>
<p><code>    </code><code>test</code> <code>-z ${project_clone_depends_1} || git_project_clone </code><code>"$project_clone_depends_1"</code></p>
<p><code>    </code><code>git_project_clone </code><code>"$project_clone"</code></p>
<p><code>    </code><code>test</code> <code>-z ${project_clone_depends_1} || maven_build_project </code><code>"$project_clone_depends_1"</code></p>
<p><code>    </code><code>maven_build_project </code><code>"$project_clone"</code></p>
<p><code>    </code><code>cd</code> <code>${WORKDIR}</code></p>
<p> </p>
<p><code>    </code><code># links_target_directory_to_current</code></p>
<p><code>    </code><code># Make directory to release directory</code></p>
<p><code>    </code><code>if</code> <code>test</code> <code>! -d ${WORKDIR}</code><code>/release</code> <code>-o ! -d ${WORKDIR}</code><code>/share</code><code>; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"capistrano directory structure is broken, make sure the file .capistrano_ds_lock is deleted before a new deploy! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>#        test -f ${WORKDIR}/.capistrano_ds_lock &amp;&amp; \rm -rf  ${WORKDIR}/.capistrano_ds_lock</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code>new_release_just_created=</code><code>"$WORKDIR/release/$(date +%Y%m%d%H%M%S)"</code></p>
<p><code>    </code><code>[ ! -d ${new_release_just_created} ] &amp;&amp; </code><code>mkdir</code> <code>${new_release_just_created}</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/repository/</code><code>${project_clone_repository_name}</code><code>/target/</code><code>${project_clone_repository_name}/ ] &amp;&amp; \</code></p>
<p><code>        </code><code>\</code><code>cp</code> <code>-rf ${WORKDIR}</code><code>/repository/</code><code>${project_clone_repository_name}</code><code>/target/</code><code>${project_clone_repository_name}/* ${new_release_just_created}</code></p>
<p><code>     </code><code># Make source code symbolic link to current</code></p>
<p><code>    </code><code>( [ -f ${WORKDIR}</code><code>/current</code> <code>] || [ -d ${WORKDIR}</code><code>/current</code> <code>] ) &amp;&amp; </code><code>rm</code> <code>-rf ${WORKDIR}</code><code>/current</code></p>
<p><code>    </code><code>ln</code> <code>-s ${new_release_just_created} ${WORKDIR}</code><code>/current</code></p>
<p> </p>
<p><code>    </code><code># backup remote host config files</code></p>
<p><code>    </code><code>backup_remote_host_config_files</code></p>
<p> </p>
<p><code>#    scp_local_files_to_remote_host ${WORKDIR}/current/ ${deploy_target_host_ip} ${project_top_directory_to_target_host}</code></p>
<p><code>    </code><code>saved_IFS=$IFS</code></p>
<p><code>    </code><code>IFS=</code><code>' '</code></p>
<p><code>    </code><code>cd</code> <code>${WORKDIR}</code><code>/current</code></p>
<p><code>    </code><code>for</code> <code>file</code> <code>in</code> <code>${WORKDIR}</code><code>/current/</code><code>*;</code><code>do</code></p>
<p><code>        </code><code>scp_local_files_to_remote_host ${</code><code>file</code><code>} ${deploy_target_host_ip} ${project_top_directory_to_target_host}</code></p>
<p><code>    </code><code>done</code></p>
<p><code>    </code><code>cd</code> <code>${WORKDIR}</code></p>
<p><code>    </code><code>IFS=${saved_IFS}</code></p>
<p> </p>
<p><code>    </code><code># rollback remote host config files</code></p>
<p><code>    </code><code>rollback_remote_host_config_files</code></p>
<p> </p>
<p><code>    </code><code># Move conf and logs directives from release to share</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/release/conf</code> <code>] &amp;&amp; </code><code>mv</code> <code>${WORKDIR}</code><code>/release/conf</code> <code>${WORKDIR}</code><code>/share/conf</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/release/logs</code> <code>] &amp;&amp; </code><code>mv</code> <code>${WORKDIR}</code><code>/release/logs</code> <code>${WORKDIR}</code><code>/share/logs</code></p>
<p> </p>
<p><code>    </code><code># Make conf and logs symbolic link to current</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/share/conf</code> <code>] &amp;&amp; </code><code>ln</code> <code>-s ${WORKDIR}</code><code>/share/conf</code> <code>${WORKDIR}</code><code>/current/conf</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/share/logs</code> <code>] &amp;&amp; </code><code>ln</code> <code>-s ${WORKDIR}</code><code>/share/logs</code> <code>${WORKDIR}</code><code>/current/logs</code></p>
<p> </p>
<p><code>    </code><code># Start service or validate status</code></p>
<p><code>    </code><code>if</code> <code>[[ -e ${WORKDIR}</code><code>/current/bin/startup</code><code>.sh ]]; </code><code>then</code></p>
<p><code>        </code><code>${WORKDIR}</code><code>/current/bin/startup</code><code>.sh start</code></p>
<p><code>        </code><code>RETVAL=$?</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code># TODO(Guodong Ding) external health check</code></p>
<p><code>        </code><code>test</code> <code>-z ${docker_container_name} || restart_docker_container ${docker_container_name}</code></p>
<p><code>        </code><code>RETVAL=$?</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>    </code><code># if started ok, then create a workable program to a file</code></p>
<p><code>    </code><code>if</code> <code>[[ ${RETVAL} -</code><code>eq</code> <code>0 ]]; </code><code>then</code></p>
<p><code>    </code><code># Note cat with eof must start at row 0, and with eof end only, such as no blank spaces, etc</code></p>
<p><code>    </code><code>cat</code> <code>&gt;${WORKDIR}</code><code>/share/workable_program</code><code>.log &lt;&lt;eof</code></p>
<p><code>${new_release_just_created}</code></p>
<p><code>eof</code></p>
<p><code>    </code><code>echo_g </code><code>"Deploy successfully! "</code></p>
<p><code>    </code><code>echo_g </code><code>"current workable version is $(cat ${WORKDIR}/share/workable_program.log)"</code></p>
<p><code>#    ls --color=auto -l ${WORKDIR}/current</code></p>
<p><code>#    ls --color=auto -l ${WORKDIR}/current/</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo_r </code><code>"Error: Deploy failed! "</code></p>
<p><code>        </code><code>${WORKDIR}/`</code><code>basename</code> <code>$0` rollback</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code># Rollback to last right configuration</code></p>
<p><code>function</code> <code>rollback() {</code></p>
<p><code>    </code><code>[ -n </code><code>"$header"</code> <code>] &amp;&amp; </code><code>echo</code> <code>"$header"</code></p>
<p><code>    </code><code>echo_b </code><code>"Rollback to last right configuration... "</code></p>
<p><code>    </code><code># The key is find last files which can work</code></p>
<p><code>    </code><code>WORKABLE_PROGRAM=`</code><code>cat</code> <code>${WORKDIR}</code><code>/share/workable_program</code><code>.log`</code></p>
<p><code>    </code><code>if</code> <code>[[ -z ${WORKABLE_PROGRAM} ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_r </code><code>"Error: Can NOT find workable release version! Please check if it is first deployment! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>    </code><code># Stop service if we have</code></p>
<p><code>    </code><code>if</code> <code>[[ -e ${WORKDIR}</code><code>/current/bin/startup</code><code>.sh ]]; </code><code>then</code></p>
<p><code>        </code><code>${WORKDIR}</code><code>/current/bin/startup</code><code>.sh stop</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>    </code><code># Remove failed deploy</code></p>
<p><code>    </code><code>rm</code> <code>-rf ${WORKDIR}</code><code>/current</code></p>
<p> </p>
<p><code>    </code><code># Remake source code symbolic link to current</code></p>
<p><code>    </code><code>ln</code> <code>-s ${WORKABLE_PROGRAM} ${WORKDIR}</code><code>/current</code></p>
<p> </p>
<p><code>    </code><code># Remake conf and logs symbolic link to current</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/share/conf</code> <code>] &amp;&amp; </code><code>ln</code> <code>-s ${WORKDIR}</code><code>/share/conf</code> <code>${WORKDIR}</code><code>/current</code></p>
<p><code>    </code><code>[ -d ${WORKDIR}</code><code>/share/logs</code> <code>] &amp;&amp; </code><code>ln</code> <code>-s ${WORKDIR}</code><code>/share/logs</code> <code>${WORKDIR}</code><code>/current</code></p>
<p> </p>
<p><code>    </code><code># Start service or validate status</code></p>
<p><code>    </code><code>if</code> <code>[[ -e ${WORKDIR}</code><code>/current/bin/startup</code><code>.sh ]]; </code><code>then</code></p>
<p><code>        </code><code>${WORKDIR}</code><code>/current/bin/startup</code><code>.sh start</code></p>
<p><code>        </code><code>RETVAL=$?</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code># TODO(Guodong Ding) external health check</code></p>
<p><code>        </code><code>test</code> <code>-z ${docker_container_name} || restart_docker_container ${docker_container_name}</code></p>
<p><code>        </code><code>RETVAL=$?</code></p>
<p><code>    </code><code>fi</code></p>
<p> </p>
<p><code>    </code><code># if started ok, then create a workable program to a file</code></p>
<p><code>    </code><code>if</code> <code>[[ ${RETVAL} -</code><code>eq</code> <code>0 ]]; </code><code>then</code></p>
<p><code>        </code><code>echo_g </code><code>"Rollback successfully! "</code></p>
<p><code>        </code><code>echo_g </code><code>"current workable version is $WORKABLE_PROGRAM"</code></p>
<p><code>#        ls --color=auto -l ${WORKDIR}/current</code></p>
<p><code>    </code><code>fi</code></p>
<p><code>}</code></p>
<p> </p>
<p><code>function</code> <code>destroy() {</code></p>
<p><code>    </code><code>[ -n </code><code>"$header"</code> <code>] &amp;&amp; </code><code>echo</code> <code>"$header"</code></p>
<p><code>    </code><code># echo a Warning message</code></p>
<p><code>    </code><code>echo_y </code><code>"Warning: This action will destroy all this project, and this is unrecoverable! "</code></p>
<p><code>    </code><code>answer=</code><code>"n"</code></p>
<p><code>    </code><code>echo_y </code><code>"Do you want to destroy this project? "</code></p>
<p><code>    </code><code>read</code> <code>-p </code><code>"(Default no,if you want please input: y ,if not please press the enter button):"</code> <code>answer</code></p>
<p><code>    </code><code>case</code> <code>"$answer"</code> <code>in</code></p>
<p><code>        </code><code>y|Y|Yes|YES|</code><code>yes</code><code>|yES|yEs|YeS|yeS )</code></p>
<p><code>        </code><code># delete all file expect for this script self</code></p>
<p><code>        </code><code># find: warning: Unix filenames usually don't contain slashes (though pathnames do).  That means that '-name `./deploy.sh'' will probably evaluate to false all the time on this system.  You might find the '-wholename' test more useful, or perhaps '-samefile'.  Alternatively, if you are using GNU grep, you could use 'find ... -print0 | grep -FzZ `./deploy.sh''.</code></p>
<p><code>            </code><code># echo $WORKDIR/</code></p>
<p><code>            </code><code>#find -L $WORKDIR -type f ! -name "$(basename $0)" -exec ls --color=auto -al {} \;</code></p>
<p><code>            </code><code># find -L . -type f ! -name "deploy.sh" -exec ls --color=auto -al {} \;</code></p>
<p><code>            </code><code># find -L . -type d -exec ls --color=auto -al {} \;</code></p>
<p><code>            </code><code># find -L ./ -maxdepth 1 ! -name "deploy.sh" ! -wholename "./"</code></p>
<p><code>        </code><code># ls | grep -v "filename" | xargs rm -rf</code></p>
<p><code>        </code><code>find</code> <code>-L ${WORKDIR} -maxdepth 1 ! -name </code><code>"$(basename $0)"</code> <code>! -wholename </code><code>"$WORKDIR"</code>  <code>-</code><code>exec</code> <code>rm</code> <code>-rf </code><code>'{}'</code> <code>\;</code></p>
<p><code>        </code><code>if</code> <code>[ $? -</code><code>eq</code> <code>0 ];</code><code>then</code></p>
<p><code>            </code><code>test</code> <code>-f ${WORKDIR}/.capistrano_ds_lock &amp;&amp; \</code><code>rm</code> <code>-rf  ${WORKDIR}/.capistrano_ds_lock</code></p>
<p><code>            </code><code>echo_g </code><code>"Destroy this project successfully! Now will exit with status 0. "</code></p>
<p><code>            </code><code>exit</code> <code>0</code></p>
<p><code>        </code><code>else</code></p>
<p><code>            </code><code>echo_r </code><code>"Error: something go wrong! Please check or alter to Admin user! "</code></p>
<p><code>            </code><code>exit</code> <code>1</code></p>
<p><code>        </code><code>fi</code></p>
<p><code>        </code><code>;;</code></p>
<p><code>        </code><code>n|N|No|NO|no|nO)</code></p>
<p><code>        </code><code>echo_g </code><code>"destroy action is cancel"</code></p>
<p><code>        </code><code>exit</code> <code>0</code></p>
<p><code>        </code><code>;;</code></p>
<p><code>        </code><code>*)</code></p>
<p><code>        </code><code>echo_r </code><code>"Are you kidding me? You are a bad kid! "</code></p>
<p><code>        </code><code>exit</code> <code>1</code></p>
<p><code>        </code><code>;;</code></p>
<p><code>    </code><code>esac</code></p>
<p> </p>
<p><code>}</code></p>
<p> </p>
<p> </p>
<p><code>function</code> <code>main(){</code></p>
<p><code>    </code><code>lock_filename=</code><code>"lock_$$_$RANDOM"</code></p>
<p><code>#    lock_filename_full_path="/var/lock/subsys/$lock_filename"</code></p>
<p><code>    </code><code>lock_filename_full_path=</code><code>"/var/lock/$lock_filename"</code></p>
<p><code>    </code><code>if</code> <code>( </code><code>set</code> <code>-o noclobber; </code><code>echo</code> <code>"$$"</code> <code>&gt; </code><code>"$lock_filename_full_path"</code><code>) 2&gt; </code><code>/dev/null</code><code>;</code><code>then</code></p>
<p><code>        </code><code>trap</code> <code>'rm -f "$lock_filename_full_path"; exit $?'</code> <code>INT TERM EXIT</code></p>
<p><code>        </code><code># Just a test for call itself, comment it</code></p>
<p><code>         </code><code>if</code> <code>[[ $</code><code># -ne 1 ]]; then</code></p>
<p><code>#            $0 deploy</code></p>
<p><code>            </code><code>[ ! -x ${WORKDIR}/`</code><code>basename</code> <code>$0` ] &amp;&amp; </code><code>chmod</code> <code>+x ${WORKDIR}/`</code><code>basename</code> <code>$0`</code></p>
<p><code>            </code><code>${WORKDIR}/`</code><code>basename</code> <code>$0` deploy</code></p>
<p><code>            </code><code>exit</code> <code>0</code></p>
<p><code>         </code><code>fi</code></p>
<p><code>        </code><code>case</code> <code>$1 </code><code>in</code></p>
<p><code>            </code><code>deploy)</code></p>
<p><code>                </code><code>deploy</code></p>
<p><code>                </code><code>;;</code></p>
<p><code>            </code><code>rollback)</code></p>
<p><code>                </code><code>rollback</code></p>
<p><code>                </code><code>;;</code></p>
<p><code>            </code><code>destroy)</code></p>
<p><code>                </code><code>destroy</code></p>
<p><code>                </code><code>;;</code></p>
<p><code>            </code><code>help|*)</code></p>
<p><code>                </code><code>echo</code> <code>"Usage: $0 {deploy|rollback|destroy} with $0 itself"</code></p>
<p><code>                </code><code>exit</code> <code>1</code></p>
<p><code>                </code><code>;;</code></p>
<p><code>        </code><code>esac</code></p>
<p> </p>
<p><code>        </code><code>rm</code> <code>-f </code><code>"$lock_filename_full_path"</code></p>
<p><code>        </code><code>trap</code> <code>- INT TERM EXIT</code></p>
<p><code>    </code><code>else</code></p>
<p><code>        </code><code>echo</code> <code>"Failed to acquire lock: $lock_filename_full_path"</code></p>
<p><code>        </code><code>echo</code> <code>"held by $(cat ${lock_filename_full_path})"</code></p>
<p><code>fi</code></p>
<p> </p>
<p><code>}</code></p>
<p> </p>
<p><code>main $@</code></p>
<p> </p>
<p><code># debug option</code></p>
<p><code>#${_XTRACE_FUNCTIONS}</code></p>
</td>
</tr>
</tbody>
</table>
<p><strong>运行效果：</strong></p>
<p>可以尝试使用Chrome浏览器打开该页面，右键单击，选择“在新标签页中打开图片”查看清晰大图。</p>
<p>推荐Windows用户使用PyCharm（5.0.x）结合Bash Support插件编辑bash shell script文件。</p>
<p>注：由于该脚本的大幅度更新，因此最新的运行效果图可以自行运行观察。</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/7F/E0/wKiom1cwYmfh-qg1AABt77YM4VE830.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvN0YvRTAvd0tpb20xY3dZbWp4OUFoNEFBSTEtLVZvTU5nNzUwLmpwZw==.jpg"></a></p>
<p><a href="http://s3.51cto.com/wyfs02/M01/7F/DD/wKioL1cwY0WgbezdAADGfbJSWBU051.jpg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvN0YvREQvd0tpb0wxY3dZMGFUXzM0cEFBTGtPemppazdFMTg4LmpwZw==.jpg"></a></p>
<p>--end--</p>
<p>本文出自 “<a href="http://dgd2010.blog.51cto.com/" rel="external nofollow noreferrer">通信，我的最爱</a>” 博客，请务必保留此出处<a href="http://dgd2010.blog.51cto.com/1539422/1771555" rel="external nofollow noreferrer">http://dgd2010.blog.51cto.com/1539422/1771555</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 13:33:58</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%8a%a8%e5%8c%96/" title="自动化">自动化</a>, <a href="https://www.iamivan.net/tag/%e9%83%a8%e7%bd%b2/" title="部署">部署</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Linux Shell脚本之远程自动化部署java maven项目的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4Xl3z.html" rel="bookmark">Linux Shell脚本之Gitlab远程备份</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://dgd2010.blog.51cto.com/1539422/1686043 注:Gitlab是一个git服务程序,有web图形界面和一系列管理工具,具体详细介绍可以Google it. 这一篇可以说是上一篇&lt;Linux Shell脚本之Atlassian confluence远程备份方法&gt;的姊妹篇.其说明和原理是和上一篇是一样的,其核心原理都是core dump.scp.ss			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba6B0PM.html" rel="bookmark">Linux shell脚本实现CPU预警&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果CPU占用率持续达到80以上则调用打印java线程占用率堆栈的脚本,见https://github.com/oldratlee/useful-shells/blob/master/show-busy-java-threads.sh,具体用法见他的github wiki! #!/bin/bash #cpu idle percent cpu_idle=`top -b -d 1 -n 2 | grep Cpu | awk 'NR&gt;1{print $5}' | cut -f 1 -d &quot;.&q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLol5vM.html" rel="bookmark">面向 DBA 的 Linux Shell 脚本简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.itpub.net/showthread.php?s=&amp;threadid=720028 面向 DBA 的 Linux Shell 脚本简介 7 年前,Oracle 发布了 Linux 上的第一个商业数据库.从那时起,Oracle.Red Hat 和 Novell/SUSE 就不断地合作更改 Linux 内核,从而提高数据库和应用程序的性能.正因为这样,用于 Linux 的 Oracle 数据库 10g 才包含了与操作系统紧密相关的许多增强功能.DBA 比以往任何时候更需要了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXK0WlM.html" rel="bookmark">Linux Shell脚本实现检测tomcat&lowbar;linux shell</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux Shell脚本检测tomcat并自动重启 后台运行命令 sh xxx.sh &amp; 查看后台任务:jobs 召唤到前台:fg jobs编号 可以删掉while循环的代码放到crontab里面定时执行,可以将脚本直接后台运行, #!/bin/bash while [ true ] do url=&quot;http://www.jb51.net/&quot;; httpOK=`curl --connect-timeout 10 -m 60 --head --silent $url | awk			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk23GrM.html" rel="bookmark">Linux shell脚本基础学习详细介绍&lpar;完整版&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux shell脚本基础学习这里我们先来第一讲,介绍shell的语法基础,开头.注释.变量和 环境变量,向大家做一个基础的介绍,虽然不涉及具体东西,但是打好基础是以后学习轻松地前提. 1. Linux 脚本编写基础 ◆1.1 语法基本介绍1.1.1 开头 程序必须以下面的行开始(必须方在文件的第一行): #!/bin/sh 符号#!用来告诉系统它后面的参数是用来执行该文件的程序.在这个例子中我们使用/bin/sh来执行程序. 当编辑好脚本时,如果要执行该脚本,还必须使其可执行. 要使脚本可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze4BEOp.html" rel="bookmark">Linux Shell脚本查看NUMA信息</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Linux Shell脚本查看NUMA信息,本文直接给出脚本实现代码,需要的朋友可以参考下 Nova在NFV场景下会提供NUMA相关高级特性,这里提供一个脚本查看计算节点的NUMA相关信息. ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQP0eZz.html" rel="bookmark">Linux Shell脚本系列教程（一）：Shell入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Linux Shell脚本系列教程(一):Shell入门,本文讲解了Shell简介.Shell基本操作.如何打开Shell终端.Shell脚本的概念.如何运行Shell脚本.Shell脚本的注释等基础知识,需要的朋友可以参考下 一.Shell简介 诸多类Unix操作系统的设计令人惊叹.即便是在数十年后的今天,Unix式的操作系统架构仍是有史以来最佳的设计之一.这种架构最重要的一个特性就是命令行界面或者shell.shell环境使得用户能与操作系统的核心功能进行交互.术语脚本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLQlKb.html" rel="bookmark">Linux Shell脚本系列教程（二）：终端打印命令详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Linux Shell脚本系列教程(二):终端打印命令详解,本文着重讲解了echo终端打印.printf终端打印两个打印出输出命令,需要的朋友可以参考下 终端打印 终端是交互式工具,用户可以通过它与shell环境进行交互.在终端中打印文本是大多数shell脚本和工具日常需要执行的基本任务.通过终端打印,人们可以知道系统的运行状态,这对用户来说是至关重要的. echo终端打印 代码如下: echo &quot;Welcome to Bash&quot; echo 'Welcome to			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5A1anp.html" rel="bookmark">Linux Shell脚本系列教程（三）：变量和环境变量</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Linux Shell脚本系列教程(三):变量和环境变量,本文讲解了普通变量.获取字符串的长度.环境变量等内容,需要的朋友可以参考下 一.玩转变量和环境变量 变量是任何一种编程语言都必不可少的组成部分,用于存放各种类型的变量.脚本语言大多是弱类型语言(动态语言),也就是说在使用变量时,不需要事先声明变量的类型,只需要直接赋值就可以.在Bash中,每一个变量的值都是字符串.无论你给变量赋值时有没有使用引号,值都会以字符串的形式存储.有一些特殊的变量会被shell环境和操作系统			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz43YPp.html" rel="bookmark" class="title">如何使word2013自带程序翻译文档</a>
					<div>
						  自带程序翻译文档步骤1:用Word2013打开一篇文档,选中我们需要翻译的文本,然后切换到&quot;审阅&quot;选项卡,并执行&quot;语言&quot;选项组下的&quot;翻译&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVZOBz.html" rel="bookmark" class="title">Fireworks MX 2004 自由笔刷工具</a>
					<div>
						2 .自由笔刷工具 &quot;刷子&quot; 工具和&quot;铅笔&quot; 工具都可以直接在画布上画出任意线条,如图2-07. 图2-07 在&quot;刷子&quot;工具的属性对话框中可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ5jwb.html" rel="bookmark" class="title">设计观点&colon;设计师领导力的培养</a>
					<div>
						话说设计师是不太好管教的,敏感,冲动,个性鲜明,理想主义--这一切都让大家很头痛,但是我们又是爱设计师的,因为他们带给了大众很多新鲜,很多创意,很多思考,因此一些小脾气也就不那么严肃对待了.不过,当一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9Mxe5Gp.html" rel="bookmark" class="title">DHTML来模拟实现下拉菜单</a>
					<div>
						我在许多的网站上看到上面都有下拉菜单的,使得网站更栩栩如生了!象微软的主页,后来我想假如单用div和JAvascript是否也能实现了,通过几次实验也总于成功了,现在把自己想法告诉大家,希望大家网页也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwdynb.html" rel="bookmark" class="title">黑链生意改头换面卷土重来</a>
					<div>
						友情链接还有用吗?毋庸置疑,肯定是有效果的,百度只是申明那些&quot;不具有推荐意义的链接&quot;是违反搜索引擎原则的.因此,具有内容相关性,权重很高的友情链接,在搜索引擎中对网站的投票价值肯定 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3Gdkb.html" rel="bookmark" class="title">新站如何快速寻找优质的友情链接</a>
					<div>
						一个新站上线之后,如何在短期内获得好的权重和排名,外链起着至关重要的因素.套句老话&quot;内容为皇,外链为王&quot;也不是不无道理.其中友情链做为重要的外链来源之一,应该如何把它做好,也是需要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjQw3p.html" rel="bookmark" class="title">Oracle RMAN高级恢复概述（二） 基于RMAN 的恢复主题</a>
					<div>
						1.只读表空间的恢复 在默认情况下,即使丢失了只读的数据文件,RMAN也不会在执行完全恢复数据库还原操作时还原只读的数据文件. 要在完全恢复期间还原只读的数据文件,就必须在restore 命令中使用c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKn64p.html" rel="bookmark" class="title">Photoshop给草原上的人物加上韩系暗蓝色</a>
					<div>
						  Photoshop给草原上的人物加上韩系暗蓝色.素材图片明暗层次感并不强,调色的时候,我们需要调出暗部的选区,然后用曲线等工具大幅压暗,并增加蓝色;然后给高光区域增加一些淡黄色即可. 原图 最终效 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVn4Rmz.html" rel="bookmark" class="title">border&colon;none与border&colon;0使用区别</a>
					<div>
						 无边框用border:none还是border:0一直都是一个热议的问题,两者除了在渲染性能上面的差别以为,在标准浏览器中页面表现是没有任何差别的.下面一起认识一下它们本质的区别 一.border: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6e9rJb.html" rel="bookmark" class="title">关闭win8启动项的图文教程</a>
					<div>
						  1. 在传统界面,可以在任务栏右键单击选择&quot;任务管理器&quot;; 2. 点开后如果您看到的界面; 3.请点击&quot;详细信息&quot;,即可看到; 4. 点击启动后就可以看到电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYyVBb.html" rel="bookmark" class="title">Win8蓝牙脱机怎么办</a>
					<div>
						  Windows 8蓝牙脱机原因分析:Windows 8正常连接后,如果没有双击打开进行传输文件,会显示脱机状态,应该是Windows 8的一个特殊功能,类似节电,通过双击打开进行传输后正常. 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8Ko1p.html" rel="bookmark" class="title">win7电脑中的蓝牙图标不见了怎么办？</a>
					<div>
						  虽然无线连接已经成为了现在的主流,但是对于有些设备,有些用户来说,蓝牙功能也是咱们电脑中不可或缺的功能,也是咱们日常生活中需要操作到的一个功能.在之前的文章中,小编也已经详细的介绍过在ghost  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaj6az.html" rel="bookmark" class="title">巧用Win7系统任务栏做好后台程序分组分类</a>
					<div>
						Win7自带有任务栏增强工具Bins,它能够把任务栏上的多个图标分组归类,从而释放更多的空间,Windows7系统使用过程中,为了方便,用户会将程序图标锁定到任务栏中,当Windows7系统(深度技术 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z720map.html" rel="bookmark" class="title">VNXe3150是否支持快照和存储分层需求？</a>
					<div>
						  故障现象: VNXe3150是否支持快照和存储分层需求? 解决方案: VNXe3150只有文件级别的快照功能,且不支持分层技术. 如若需要支持block存储的快照以及分层技术,推荐使用VNX2代存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWxaBb.html" rel="bookmark" class="title">iOS 8正式与iPhone前辈说再见</a>
					<div>
						腾讯数码讯(编译:张秀梅)有许多事情,苹果真的很擅长.而掌握好系统与硬件产品的发布节奏,在新系统发布之后紧接着借发布搭载新系统的产品,就是苹果最擅长的事情之一.而最近刚刚正式推出的iOS 8系统再一次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Px13p.html" rel="bookmark" class="title">javascript some&lpar;&rpar;函数用法详解&lowbar;php技巧</a>
					<div>
						参数说明 callback: 要对每个数组元素执行的回调函数. thisObject : 在执行回调函数时定义的this对象. 功能说明 对数组中的每个元素都执行一次指定的函数(callback),直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N36NM.html" rel="bookmark" class="title">【斗医】【17】Web应用开发20天</a>
					<div>
						原创作品,允许转载,转载时请务必以超链接形式标明文章 原始出处 .作者信息和本声明.否则将追究法律责任.http://qingkechina.blog.51cto.com/5552198/154391 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P9O3p.html" rel="bookmark" class="title">java-Java中用TreeSet方法排序字符型数字怎么排序啊，求指教，谢谢</a>
					<div>
						问题描述 Java中用TreeSet方法排序字符型数字怎么排序啊,求指教,谢谢 public class Demo implements Comparable{ //String str; Strin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQBwZp.html" rel="bookmark" class="title">js判断浏览器类型</a>
					<div>
						其实jQuery 也可以判断浏览器类型,但是从1.9之后就删除了$.browser  所以我没有使用jQuery 测试页面: Html代码   &lt;html&gt;   &lt;head lang ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE61JJM.html" rel="bookmark" class="title">javascript-js，onchange时间做的&OpenCurlyDoubleQuote;随写随算&rdquo;的功能代码</a>
					<div>
						问题描述 js,onchange时间做的&quot;随写随算&quot;的功能代码 下面是我通过js,onchange时间做的&quot;随写随算&quot;的功能代码,就是比如我改变净重,那么金额也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRaKYp.html" rel="bookmark" class="title">settheme-android在程序中用setTheme设置主题，小米2上测试无效，大牛求解～</a>
					<div>
						问题描述 android在程序中用setTheme设置主题,小米2上测试无效,大牛求解- @Override public void onCreate(Bundle savedInstanceStat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRykAb.html" rel="bookmark" class="title">数据操作-指针空间分配问题？debug出错了</a>
					<div>
						问题描述 指针空间分配问题?debug出错了 typedef string ElemType; typedef struct LNode { ElemType data; struct LNode n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN53xM.html" rel="bookmark" class="title">OSGi中bundle两阶段更新的细节是怎么样的？</a>
					<div>
						问题描述 刚刚研究osgi,当前对osgi的组件动态升级觉得很有趣.在&lt;OSGi实战&gt;这本书的Ch3.5.2Refreshingbundles一节里讲了一些组件动态升级的过程:Bundle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWPQXM.html" rel="bookmark" class="title">我该用什么数据库？</a>
					<div>
						问题描述 公司要做自己的官方网站,在数据库的选择上产生了点分歧:Oracle/MySQL/MongoDB三款数据库该选哪一个,数据量不是太大但需要频繁查询读取数据.据我了解,Oracle功能很强但貌似 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZyy6p.html" rel="bookmark" class="title">js-ie下使用jQuery获取对象并设置值出错，火狐下正常</a>
					<div>
						问题描述 ie下使用jQuery获取对象并设置值出错,火狐下正常 调试时控制台不断输出错误信息: 获取的是input,input是在js中动态添加上的,鼠标移上去就会显示出来 为input绑定了一个& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAk6dvz.html" rel="bookmark" class="title">ASP&period;NET中的跳转 200&comma; 301&comma; 302转向实现代码&lowbar;实用技巧</a>
					<div>
						跳转时的HTTP的状态码一般为200,301,302中的一个,下面先列出各状态码出现的情况,然后再解释各状态码有什么不同: 状态码200的跳转: 1. &lt;meta http-equiv=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYaR6b.html" rel="bookmark" class="title">PPT实现折线图表与数据对应变化的图文教程&lpar;计步器实例&rpar;</a>
					<div>
						第一步:打开powerpoint 2013后插入图表:(10版本可做出类似效果,但部分功能缺失,推荐使用13版) 第二步:插入组合图表,在窗口中修改图表属性:折线图.面积图.散点图,勾选散点图后的&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWPGwp.html" rel="bookmark" class="title">高通每天提供超过一百万颗芯片 助力物联网发展</a>
					<div>
						高通公司今日通过子公司Qualcomm Technologies, Inc. 在其物联网(IoT)行业分析师沟通会上宣布,目前公司每天出货超过一百万颗物联网芯片.这一里程碑体现了Qualcomm Te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlANG8p.html" rel="bookmark" class="title">见证新网在未来发展中的战略布局</a>
					<div>
						摘要: 近期,小编参加了赢聚变2014新网全国巡回合作伙伴大会,见证新网在未来发展中的战略布局,与南京合作伙伴的良好关系.会上,.在线域通联达注册局首席执行官和联合创始人ArtoIsok近期,小编参加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdOZ8z.html" rel="bookmark" class="title">Android平台的10款开源任务管理和时间追踪应用</a>
					<div>
						现代生活需求的压力有时候会把人压倒.即使是一个十分有组织能力的人或许也会需要数字工具来跟踪个人和专业的会议以及最后期限. 如果你参加了今年的 All Things Open,可能已经看到了 Opens ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.334 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
